'-----------------------------------------------------------------------------
'SERIOUS-LOOKING FILE SELECTOR  BY ANTONI GUAL agual@eic.ictnet.es
'----------------------------------------------------------------------------
' Returns full path of a file and does'nt change default path
'
' Use as you want, only give me credit
'
' FEATURES:
' Should not display DOS error messages when disk not ready
' Tested in Win 95/98 and  DOS 6.1-Win 3.11.
' Auto detects num of screen lines set by main program.
' Tested with QBasic
' Not self contained, needs getcurdir,DiskReady and DetectWinTemp routines!
' No mouse!
' In W9x displays LFN, returns 8.3 format QB file functions can't handle LFN)
' You can escape the file selection!
'
' REMARKS:
' For non Win 9x users: It Runs faster if temp path is set to a RAM drive!
' Creates some auxiliar files: To do it, uses path in temp system variable
' To use it with DOS < 5.0 try changing constant DOS to 3 (Sorry..I.Can't test it)
'-----------------------------------------------------------------------------


DECLARE SUB detectwintemp ()
DECLARE FUNCTION getcurdir$ (save%)
DECLARE FUNCTION DiskReady% (d$)
DECLARE FUNCTION SelectAFile$ (header$, ext$)

'these three lines MUST be in your main program
DIM SHARED temppath$, win AS INTEGER
CONST false = 0, true = NOT false
detectwintemp


'-----------------------demo-----------------------------------
SCREEN 0: WIDTH , 50: CLS
SCREEN 0: COLOR 7, 1: WIDTH , 50: CLS
'GOTO sel
LOCATE 1, 1: PRINT CHR$(201); STRING$(78, 205); CHR$(187);
FOR i = 2 TO 23
LOCATE i, 1: PRINT CHR$(186); : LOCATE , 80: PRINT CHR$(186);
NEXT
LOCATE 24, 1: PRINT CHR$(200); STRING$(78, 205); CHR$(188);
COLOR 14
LOCATE 2, 31: PRINT "DiskReady Sub DEMO"
COLOR 7
LOCATE 5, 32: PRINT "Testing drives...";
FOR i = ASC("A") TO ASC("L")
    a$ = CHR$(i)
    b = DiskReady(a$)
    LOCATE i - 58, 2
    SELECT CASE b
    CASE 0: PRINT "Bingo!: Drive "; a$; ": is not broken yet!";
    CASE 1: PRINT "Where am I supposed to read data? Air? Put something in drive "; a$; "!";
    CASE 2: PRINT "It's a joke? You did'nt pay enough for your PC to have a drive named "; a$; ":";
    CASE 3: PRINT "You're supposed to be working hard! What's all that rock'n roll in drive "; a$; ":?";
    END SELECT
NEXT
LOCATE 22, 22: PRINT "Press any key to go to SelectAFile Sub Demo..";
a$ = INPUT$(1)
sel:
SCREEN 0: COLOR 7, 1: WIDTH , 50: CLS
LOCATE 6: PRINT "Current dir is ": SHELL "CD"
LOCATE 8: PRINT "And if you press a key you will be prompted to select a file!"
a$ = INPUT$(1)
PCOPY 0, 1

a$ = SelectAFile$("Select any file: I will do absolutely nothing with it!", "bas")
PCOPY 1, 0
COLOR 7, 1
IF LEN(a$) THEN
    LOCATE 10: PRINT "You selected: "; a$
    OPEN a$ FOR BINARY AS #1:
    SHELL "echo I opened it and i found It has " + STR$(LOF(1)) + " bytes"
    CLOSE
ELSE
    LOCATE 10: PRINT "You exit SelectAFile without selecting anything"
END IF
SHELL "echo."
SHELL "echo And Current dir is still": SHELL "CD"
PRINT "press any key": a$ = INPUT$(1)
SCREEN 0: COLOR 7, 1: WIDTH , 25: CLS
a$ = SelectAFile$("Here We Go Again!", "*")
LOCATE 10: PRINT "You selected: "; a$
'--------------------------END OF DEMO----------------------------------------

END

'this line must be after the END of your program!
diskreadyerror: errata% = ERR: RESUME NEXT

DEFINT A-Z
SUB detectwintemp
'detect Windows 95 and the temp path, setting global variables
'used by  all routines based in SHELL commands, i.e. the file selector
'or the current dir saver

'find temp path
temppath$ = ENVIRON$("TEMP") + "\"
IF temppath$ = "\" THEN
        PRINT "Sorry. Some routines in this program require the TEMP variable to be set"
        END
END IF

'detect windows 95 & 98
tempfile$ = temppath$ + "detwin.txt"
doscmd$ = "ver >" + tempfile$
SHELL doscmd$
f1 = FREEFILE: OPEN tempfile$ FOR INPUT AS #f1:
win = 0
WHILE NOT EOF(f1) AND win = 0
    LINE INPUT #f1, a$
    IF INSTR(a$, "Windows") THEN win = -1
WEND
CLOSE f1
KILL tempfile$
END SUB

FUNCTION DiskReady% (d$)
'
'Nearly Self-contained drive check routine
' Use as you want, only give me credit
'
'returns:   0 if drive exists and it's ready
'           1 if drive is not ready
'           2 if drive does not exist
'           3 if drive exists and disk is an audio CD
'
'supposed to run in any dos from MSDOS 3.1. Tested in Win 95 and DOS 6.2
'detects RAM disks and it's supposed to detect network units
'Does not use interrupt calls!
'---------------------------------------------------------------------------
'To use it into your programs simply copy it and add the line
'   diskreadyerror: errata% = ERR: RESUME NEXT
'(without the leading ') after the END of the main program
'---------------------------------------------------------------------------
SHARED errata%
errata% = 0
drive$ = LEFT$(UCASE$(d$), 1) + ":"
IF drive$ = "B:" THEN
    OUT &H70, &H10
    IF (INP(&H71) AND 7) = 0 THEN DiskReady% = 2: EXIT FUNCTION
END IF
ON ERROR GOTO diskreadyerror
num% = FREEFILE
OPEN drive$ + "\track01.cda" FOR INPUT AS #num%
SELECT CASE errata%
    CASE 53: DiskReady% = 0
    CASE 71: DiskReady% = 1
    CASE 76: DiskReady% = 2
    CASE 0: DiskReady% = 3: CLOSE num%
    CASE ELSE
        PRINT "Unexpected error value "; errata%; "in Diskready function": END
END SELECT
ON ERROR GOTO 0

END FUNCTION

FUNCTION getcurdir$ (save%)
'if save <>0 then save cur dir
'if save =0 then chdir to curdir
'needs the shared variables temppath$ and win to be set

STATIC a$
IF save% THEN
    tempfile$ = temppath$ + "curdir.txt"
    SHELL "cd >" + tempfile$
    f% = FREEFILE: OPEN tempfile$ FOR INPUT AS f%
    LINE INPUT #f%, a$
    CLOSE f%: KILL tempfile$
    IF LEFT$(a$, 1) <> "\" THEN a$ = a$ + "\"
ELSE
    IF win THEN a1$ = CHR$(34) + a$ ELSE a1$ = a$
    SHELL a1$
    SHELL "cd " + a1$
END IF
getcurdir$ = a$
END FUNCTION

FUNCTION SelectAFile$ (header$, ext$)
'
' User friendly file selector routine.Returns full path of a file
' by Antoni Gual agual@eic.ictnet.es
' Fully reprogrammed from a layout by William Yu
'
' Use as you want, only give me credit
'
' FEATURES:
' Should not display DOS error messages when disk not ready
' Tested in Win 95/98 and  DOS 6.1-Win 3.11.
' Auto detects num of screen lines set by main program.
' Tested with QBasic
' Not self contained, needs DiskReady and DetectWinTemp routines!
' No mouse!
' In W95/98 displays LFN, but returns 8.3 format
'   (QB file functions can't handle LFN)
'
' REMARKS:
' For non Win 9x users: It Runs faster if temp path is set to a RAM drive!
' Creates some auxiliar files: To do it, uses path in temp system variable
' To use it with DOS < 5.0 try changing constant DOS to 3 (Sorry..I.Can't test it)
' To avoid drive checking each time the routine is run, read comment
'    6 lines above EXIT FUNCTION
'
'-------------------------------------------------------------------------
    'PUT DOS TO 3 IF THE PROGRAM HAS TO RUN UNDER DOS BELOW 5.0
    DIM z$
    CONST dos = 5

    'keys
    CONST kpgup = -&H49, kpgdn = -&H51
    CONST kleft = -&H4B, kright = -&H4D, kup = -&H48, kdown = -&H50
    CONST kenter = &HD, kesc = &H1B

    q$ = CHR$(34)

    'colors
    CONST fgiuns = 7, bgiuns = 0, fgauns = 15, bgauns = 0
    CONST fgisel = 12, bgisel = 0, fgasel = 15, bgasel = 4

    'auxiliar files
    DIM auxf$(1 TO 3):
    auxf$(3) = temppath$ + "}{drive.lst": auxf$(2) = temppath$ + "}{dir.lst"
    auxf$(1) = temppath$ + "}{file.lst"
    tempfile$ = temppath$ + "temp.txt"
  
    'Detect Nr of lines of screen
    DEF SEG = &H40
    scrl = PEEK(&H84) + 1
    DEF SEG

    DIM wd(0 TO 4, 1 TO 3)
    'vertical window sizes
    CONST wintop = 8
    winbot = scrl - 7: winheight = winbot - wintop + 1

    'indexs ( they avoid for a type definition in the main module)
    CONST wdxpos = 0, wdwdth = 1, wdtop = 2, wdcur = 3, wdcount = 4


    'init
    wd(wdxpos, 1) = 8: wd(wdxpos, 2) = 38: wd(wdxpos, 3) = 68
    IF win THEN
        wd(wdwdth, 1) = 24: wd(wdwdth, 2) = 24: wd(wdwdth, 3) = 6
    ELSE
        wd(wdwdth, 1) = 12: wd(wdwdth, 2) = 8: wd(wdwdth, 3) = 6
    END IF
    wd(wdtop, 1) = 1: wd(wdtop, 2) = 1: wd(wdtop, 3) = 1


    'strings with windows width
    DIM t$(1 TO 3): FOR i = 1 TO 3: t$(i) = SPACE$(wd(wdwdth, i)): NEXT
    h$ = SPACE$(64)


    'prepare command strings
    IF dos = 5 THEN
        IF win THEN x$ = " /Z"
            dosdirs$ = "DIR  /AD /ON /B >>" + auxf$(2)
           dosfiles$ = "DIR *." + ext$ + " /A-D /ON /B >" + auxf$(1)
    ELSE
        dosdirs$ = "DIR *.* |FIND " + q$ + "<DIR>" + q$ + " >>" + auxf$(2)
        dosfiles$ = "DIR *." + ext$ + " | FIND " + q$ + ":" + q$ + "|FIND /V " + q$
        dosfiles$ = dosfiles$ + "<DIR>" + q$ + "|FIND /V " + q$ + ":\" + q$ + " >" + auxf$(1)
    END IF

    temp = INSTR(ext$, "."): IF temp THEN ext$ = MID$(ext$, temp + 1)

    'check all possible drives and build a drive list
    file$ = auxf$(3): GOSUB filexist
    IF exist = false THEN
        f = FREEFILE: OPEN auxf$(3) FOR OUTPUT AS #f
        COLOR 7, 0: CLS : PRINT "Checking existing drives: please wait!"
        FOR i = ASC("A") TO ASC("Z")
            IF DiskReady(CHR$(i)) <> 2 THEN
                LSET t$(3) = "-[" + CHR$(i) + ":]-"
                PRINT #f, t$(3)
            END IF
        NEXT
        CLOSE #f
    END IF
    f = FREEFILE: OPEN auxf$(3) FOR INPUT AS #f
    w1 = 3: GOSUB ITEMCOUNT
    CLOSE f

    'init screen
    SCREEN 0: COLOR 7, 1: CLS
    COLOR 14: LOCATE 1, 40 - LEN(header$) \ 2: PRINT header$;
    'top rectangle
    LOCATE 3, 4: COLOR 9, 0: PRINT CHR$(218); STRING$(72, 196); CHR$(191)
    LOCATE 4, 4: PRINT CHR$(179); STRING$(72, 0); CHR$(179)
    LOCATE 5, 4: PRINT CHR$(192); STRING$(72, 196); CHR$(217)

    'other rectangles
    FOR x1 = 1 TO 3: GOSUB rect: NEXT
    COLOR 14, 1: LOCATE scrl - 2, 2
    PRINT "Up/Dn Pgup/PgDn Move cursor, Left/Right Change Panel, Enter Select, Esc Quit";

    'clear keyboard buffer
    WHILE LEN(INKEY$): WEND

    'init drive an dir cursor
    GOSUB curdir
  
    'cursor will start in files window
    actwin = 1
 
    'here we enter the main loop
updatedrive:
    f = FREEFILE: OPEN auxf$(3) FOR INPUT AS #f
        w1 = 3: GOSUB updatewin
    CLOSE f

'update dir list
updatedir:

    GOSUB curdir
    f = FREEFILE
    IF dos = 5 THEN
        OPEN auxf$(2) FOR OUTPUT AS #f
        IF LEN(curdir$) > 3 THEN PRINT #f, ".."
        CLOSE f
    END IF
    SHELL dosdirs$
    OPEN auxf$(2) FOR INPUT AS #f
        w1 = 2: GOSUB ITEMCOUNT: GOSUB updatewin
    CLOSE f

    'update file list
    SHELL dosfiles$
    f = FREEFILE: OPEN auxf$(1) FOR INPUT AS #f
        w1 = 1: GOSUB ITEMCOUNT: GOSUB updatewin
        IF wd(wdcount, 1) = 0 THEN actwin = 2: w1 = 2: GOSUB updatewin
    CLOSE f

'keys loop
'program will stay in this loop unless window change or press enter or esc
movecursor:
    w1 = actwin
    OPEN auxf$(actwin) FOR INPUT AS #f
    DO
        GOSUB updatewin
        DO: V$ = INKEY$: LOOP UNTIL LEN(V$)
        V = ASC(RIGHT$(V$, 1)): IF ASC(V$) = 0 THEN V = -V
        SELECT CASE V
        CASE kup:
             wd(wdcur, w1) = wd(wdcur, w1) - 1
             IF wd(wdcur, w1) < 1 THEN wd(wdcur, w1) = 1
        CASE kdown:
             wd(wdcur, w1) = wd(wdcur, w1) + 1
             IF wd(wdcur, w1) > wd(wdcount, w1) THEN wd(wdcur, w1) = wd(wdcount, w1)
        CASE kpgup:
             wd(wdcur, w1) = wd(wdcur, w1) - winheight
             IF wd(wdcur, w1) < 1 THEN wd(wdcur, w1) = 1
        CASE kpgdn:
             wd(wdcur, w1) = wd(wdcur, w1) + winheight
             IF wd(wdcur, w1) > wd(wdcount, w1) THEN wd(wdcur, w1) = wd(wdcount, w1)
        'change active window
        CASE kleft:
            IF actwin > 1 THEN
               IF actwin <> 2 OR wd(wdcount, 1) > 0 THEN
                actwin = actwin - 1: GOSUB updatewin: CLOSE #f: GOTO movecursor
               END IF
            END IF
        'change active window
        CASE kright:
            IF actwin < 3 THEN
                actwin = actwin + 1: GOSUB updatewin: CLOSE #f: GOTO movecursor
            END IF
        'select file in file window, change dir or drive in other windows
        CASE kenter:
            WHILE DiskReady(newdrive$) = 1
                err$ = "Disk " + newdrive$ + " not ready   [R]etry/[C]ancel?": GOSUB errmsg
                IF a$ <> "R" THEN CLOSE f: SHELL "C:": GOTO updatedrive
            WEND
            SELECT CASE actwin
            'select file and exit
            CASE 1:
                IF LEN(newfile$) THEN
                    CLOSE f: TMP$ = curdir$ + newfile$
                    IF win THEN
                        'truename fails with filenames so i use it only with dir name
                        doscmd$ = "TRUENAME |find " + q$ + ":\" + q$ + ">" + tempfile$
                        SHELL doscmd$
                        OPEN tempfile$ FOR INPUT AS f: LINE INPUT #f, TP$: CLOSE f
                        TMP$ = TP$: IF LEN(TMP$) > 3 THEN TMP$ = TMP$ + "\"
                        KILL tempfile$
                        doscmd$ = "DIR /A-D " + q$ + newfile$ + q$ + "|FIND " + q$ + ":" + q$ + "|FIND /V " + q$ + ":\" + q$ + ">" + tempfile$
                        SHELL doscmd$
                        OPEN tempfile$ FOR INPUT AS f: LINE INPUT #f, TP$: CLOSE f
                        t$ = SPACE$(12): LSET t$ = TP$: MID$(t$, 9) = "."
                        TMP$ = TMP$ + RTRIM$(t$)
                    END IF
                    SelectAFile$ = TMP$: EXIT DO
                ELSE
                    actwin = actwin + 1: GOSUB updatewin
                END IF
            'change dir
            CASE 2:
                IF newdir$ <> "." THEN
                    IF (LEN(curdir$) > 3) OR (newdir$ <> "..") THEN
                        CLOSE f: SHELL "CD " + newdir$: GOTO updatedir
                    END IF
                END IF
            'change drive
            CASE 3:
                 CLOSE f: SHELL newdrive$: GOTO updatedrive
            END SELECT
        CASE kesc:
            CLOSE #f: SelectAFile$ = "": EXIT DO
        END SELECT
    LOOP
    KILL auxf$(1)
    KILL auxf$(2)
    'KILL auxf$(3) 'this file (}{drive.lst) keeps the list of valid drives
    '              to avoid drive testing each time the routine is run
    '              put a REM in  this line and erase the file at program's end.
    '              (Or don't erase it, if your drives are all fixed)
    IF win THEN z$ = q$ ELSE z$ = ""
    CLS
EXIT FUNCTION

'---------------------------gosubs------------------------------------------
'update window W1 from the contents of already opened file f
updatewin:
    SEEK #f, 1
    IF actwin = w1 THEN isactive = true ELSE isactive = false
    IF wd(wdcur, w1) < wd(wdtop, w1) THEN wd(wdtop, w1) = wd(wdcur, w1)
    IF wd(wdcur, w1) > (wd(wdtop, w1) + winheight - 1) THEN wd(wdtop, w1) = wd(wdcur, w1) - winheight + 1
    i = 1: j = wintop: K = wd(wdleft, w1)
    WHILE NOT EOF(f) AND j <= winbot
        LINE INPUT #f, a$
        IF i >= wd(wdtop, w1) THEN
            LSET t$(w1) = a$
            IF i = wd(wdcur, w1) THEN
                IF isactive THEN COLOR fgasel, bgasel ELSE COLOR fgisel, bgisel
                SELECT CASE w1
                 CASE 1: newfile$ = RTRIM$(a$)
                    'IF LEN(NEWFILE$) > 9 THEN MID$(NEWFILE$, 9) = "."
                 CASE 2: newdir$ = RTRIM$(a$): IF win THEN newdir$ = q$ + newdir$
                 CASE 3: newdrive$ = MID$(t$(w1), 3, 2)
                END SELECT
            ELSE
                IF isactive THEN COLOR fgauns, bgauns ELSE COLOR fgiuns, bgiuns
            END IF
            LOCATE j, K: PRINT t$(w1); : j = j + 1
        END IF
        i = i + 1
    WEND
    LSET t$(w1) = "": COLOR fgiuns, bgiuns
    FOR j1 = j TO winbot
       LOCATE j1, K: PRINT t$(w1)
    NEXT
RETURN

curdir:
    tempfile$ = temppath$ + "curr.dir"
    SHELL "CD > " + tempfile$
    f = FREEFILE: OPEN tempfile$ FOR INPUT AS #f
    LINE INPUT #f, curdir$
    IF LEN(curdir$) <> 3 THEN curdir$ = curdir$ + "\"
    curdrive$ = LEFT$(curdir$, 1)
    CLOSE f: KILL tempfile$
    OPEN auxf$(3) FOR INPUT AS #f
        i = 0
        DO: i = i + 1: LINE INPUT #f, a$: LOOP UNTIL INSTR(a$, curdrive$)
    CLOSE f
    wd(wdcur, 3) = i
    LSET h$ = curdir$ + "*." + ext$
    LOCATE 4, 6: COLOR 10: PRINT h$;
RETURN


'GUI: draw a shadowed rectangle, dimensions in wd(?,x1)
rect:
    COLOR 9, 7: LOCATE wintop - 1, wd(wdxpos, x1) - 1
    PRINT CHR$(218); STRING$(wd(wdwdth, x1), 196); CHR$(191)
    FOR j = wintop TO winbot
      LOCATE j, wd(wdxpos, x1) - 1
      PRINT CHR$(179); STRING$(wd(wdwdth, x1), 32); CHR$(179)
    NEXT j
    LOCATE winbot + 1, wd(wdxpos, x1) - 1
    PRINT CHR$(192); STRING$(wd(wdwdth, x1), 196); CHR$(217)
    FOR j = wintop TO winbot + 1
        LOCATE j, wd(wdxpos, x1) + wd(wdwdth, x1) + 1: COLOR 0
        PRINT STRING$(2, 219)
    NEXT j
    LOCATE winbot + 2, wd(wdxpos, x1) + 2: PRINT STRING$(wd(wdwdth, x1) + 1, 219)
RETURN

'check if a file exists
filexist:
    f = FREEFILE: OPEN file$ FOR BINARY AS #f
    IF LOF(f) = 0 THEN exist = false: CLOSE #f: KILL file$ ELSE exist = true: CLOSE #f
RETURN

'count items in list file
ITEMCOUNT:
    j = 0: WHILE NOT EOF(f): LINE INPUT #f, a$: j = j + 1: WEND
    wd(wdcount, w1) = j: wd(wdcur, w1) = 1
RETURN

'displays an eror message and waits for a key
errmsg:
    LSET h$ = err$
    LOCATE 4, 6: COLOR 12: PRINT h$;
    a$ = UCASE$(INPUT$(1)): LSET h$ = "": LOCATE 4, 6: PRINT h$
RETURN

END FUNCTION

